﻿using DryIoc.ImTools;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace StudentManager.Common
{
	public class HomeWork
	{
		public int Lesson { get; set; } = 0;
		public bool Status { get; set; } = false;
		public HashSet<ErrorInfo> QuestionInfo { get; set; } = new HashSet<ErrorInfo>();

		public void AddHomeWork(ErrorInfo workInfo)
		{
			QuestionInfo.Add(workInfo);
		}

		public void AddHomeWork(int id)
		{
			QuestionInfo.Add(new ErrorInfo { ID = id });
		}

		public void RemoveHomeWork(ErrorInfo workInfo)
		{
			QuestionInfo.Remove(workInfo);
		}

		public void Append(HomeWork homeWork)
		{
			foreach (var item in homeWork.QuestionInfo)
			{
				QuestionInfo.Add(item);
			}
			
		}
	}

	public class HomeWorkSet
	{
		private Dictionary<int, HomeWork> HomeWorks { get; set; } = new Dictionary<int, HomeWork>();


		public void AddHomeWork(HomeWork homeWork)
		{
			HomeWorks.Add(homeWork.Lesson, homeWork);
		}


		public void RemoveHomeWork(HomeWork homeWork)
		{
			HomeWorks.Remove(homeWork.Lesson);
		}

		public HomeWork Get(int cursonId)
		{
			return HomeWorks[cursonId];
		}

		public List<HomeWork> GetAll()
		{
			return HomeWorks.Values.ToList();
		}

		public ObservableCollection<HomeWork> GetAllByColl()
		{
			ObservableCollection <HomeWork> works = new ObservableCollection<HomeWork >();

			foreach (var item in HomeWorks)
            {
                works.Add(item.Value);
            }
			return works;
		}
	}

}
