﻿using StudentManager.Common;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.Json;
using System.Threading.Tasks;

namespace StudentManager.Data
{
	public static class StudentLib
	{
		public static string LibPath = "C:\\Users\\zc\\Desktop\\FileLib\\";
		public static string FileName = "studentLib.dbsi";
		public static Dictionary<int, StudentInfo> StudentDic { get; set; } = new Dictionary<int, StudentInfo>();

		public static void Add(StudentInfo studentInfo)
		{
			StudentDic.Add(studentInfo.UID, studentInfo);
		}


		public static void Load()
		{
			StudentDic.Clear();

			Debug.Assert(Path.Exists(LibPath));
			string file = File.ReadAllText(LibPath + FileName);
			StudentDic = JsonSerializer.Deserialize<Dictionary<int, StudentInfo>>(file);
		}

		public static void Save()
		{
			File.WriteAllText((LibPath + FileName), JsonSerializer.Serialize(StudentDic));
		}

		public static void Test()
		{
			StudentDic.Add(1, new StudentInfo
			{
				UID = 123,
				Name = "John Doe",
				Gender = "Male",
				Contact = "123-456-7890",
				Address = "123 Main St",
				Grade = 10,
			});
		}

		public static void Remove(StudentInfo studentInfo)
		{
			StudentDic.Remove(studentInfo.UID);
		}

		public static void Remove(int id)
		{
			StudentDic.Remove(id);
		}
	}

	public class StudentInfo
	{
		public int UID { get; set; } = 1;
		public string Name { get; set; } = "Name";
		public string Gender { get; set; } = "Gender";
		public string Contact { get; set; } = "Contact";
		public string Address { get; set; } = "Address";
		public int Grade { get; set; } = 1;

		public ErrorSet ErrorSet { get; set; } = new ErrorSet();
		public HomeWorkSet HomeWorkSet { get; set; } = new HomeWorkSet();

		public HomeWork CurentHomeWork { get; set; } = new HomeWork();


	}
}
